/*
 *   @(#) MP3 Player 1.0 Demicron (demicron@demicron.com)
 *
 *   BitStreamErrors.java   2002-09-17
 *
 *   Copyright (C) 2002  Demicron
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */



/**
 * This interface describes all error codes that can be thrown
 * in <code>BistreamException</code>s.
 *
 * @see BitstreamException
 *
 */

public interface BitstreamErrors extends JavaLayerErrors
{

	/**
	 * An undeterminable error occurred.
	 */
	static public final int UNKNOWN_ERROR = BITSTREAM_ERROR + 0;

	/**
	 * The header describes an unknown sample rate.
	 */
	static public final int UNKNOWN_SAMPLE_RATE = BITSTREAM_ERROR + 1;

	/**
	 * A problem occurred reading from the stream.
	 */
	static public final int STREAM_ERROR = BITSTREAM_ERROR + 2;

	/**
	 * The end of the stream was reached prematurely.
	 */
	static public final int UNEXPECTED_EOF = BITSTREAM_ERROR + 3;

	/**
	 * The end of the stream was reached.
	 */
	static public final int STREAM_EOF = BITSTREAM_ERROR + 4;

	/**
	 *
	 */
	static public final int BITSTREAM_LAST = 0x1ff;

}
